<?php
/**
 * @copyright   &copy; 2005-2019 PHPBoost
 * @license     https://www.gnu.org/licenses/gpl-3.0.html GNU/GPL-3.0
 * @author      Kévin BRISSEZ <brissez.kevin@gmail.com>
 * @version     PHPBoost 5.1 - last update: 2019 11 01
 * @since       PHPBoost 5.0 - 2019 07 01
 */
class NotificationsDeleteController extends ModuleController
  {
    public function execute(HTTPRequestCustom $request)
      {
        AppContext::get_session()->csrf_get_protect();
        
        $user = AppContext::get_current_user();
        
        if (!$user->check_level(User::MEMBER_LEVEL))
          {
            $error_controller = PHPBoostErrors::user_not_authorized();
            DispatchManager::redirect($error_controller);
          }
        // On récupère la notification
        $getNotification = $this->get_notification($request);
        if ($getNotification == FALSE)
          {
            // Si la notification n'existe pas, on renvoi sur la page des notifications
            AppContext::get_response()->redirect(NotificationsUrlBuilder::home());
          }
        elseif ($getNotification['recipient_id'] == $user->get_id())
          {
            // On supprime la notification   
            NotificationsService::delete('WHERE id=:id', array(
                'id' => $getNotification['id']
            ));
            AppContext::get_response()->redirect(($request->get_url_referrer() ? $request->get_url_referrer() : NotificationsUrlBuilder::home()), LangLoader::get_message('notifications.delete.success', 'common', 'notifications'));
          }
        else
          {
            // Si le recipient_id est différent de l'id du membre connecté actuellement on redirige vers la page des notifications
            AppContext::get_response()->redirect(NotificationsUrlBuilder::home());
          }
        
        
        
      }
    
    private function get_notification(HTTPRequestCustom $request)
      {
        $id = $request->get_getint('id', 0);
        try
          {
            $notification = PersistenceContext::get_querier()->select_single_row(PREFIX . 'notifications', array(
                'id, recipient_id'
            ), 'WHERE id=:id_notification', array(
                'id_notification' => $id
            ));
          }
        catch (RowNotFoundException $e)
          {
            return false;
          }
        
        return $notification;
      }
    
  }
?>